/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
package org.apache.geronimo.samples.datacdinfo.web;

import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.List;

import javax.annotation.Resource;
import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.PersistenceUnit;
import javax.persistence.Query;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.transaction.UserTransaction;

/**
 * Servlet implementation class ListOwnerServlet
 * 
 * This servlet demo how to use application-managed persistence context
 * to access database. Note that there must inject an UserTransaction resource
 * to manually manage transaction before using EntityManager to query database.
 */
public class ListOwnerServlet extends HttpServlet {
	private static final long serialVersionUID = 1L;
    
	@PersistenceUnit(unitName="DataCDInfoUnit") 
	private EntityManagerFactory emf;
	@Resource 
	private UserTransaction utx;

    /**
     * @see HttpServlet#HttpServlet()
     */
    public ListOwnerServlet() {
        super();
        // TODO Auto-generated constructor stub
    }

	/**
	 * @see HttpServlet#doGet(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		// TODO Auto-generated method stub
		service(request,response);
	}

	/**
	 * @see HttpServlet#doPost(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		// TODO Auto-generated method stub
		service(request,response);
	}
	
	protected void service(HttpServletRequest req, HttpServletResponse res)
	  throws ServletException, IOException {		
		
		List<Object[]> owners = new ArrayList<Object[]>();
		
		EntityManager em = emf.createEntityManager();
		try {
			utx.begin();
			Query query = em.createNativeQuery("select * from OWNER_TABLE");
			owners = query.getResultList();
			utx.commit();			
		} catch (Exception e){
			e.printStackTrace();
		}

		res.setContentType("text/html");
		PrintWriter out = res.getWriter();
	    
	    out.print("<html>");
	    out.print("<head><title>Registered Owners</title></head>");
	    out.print("<body>");	    

	    for (Object[] owner : owners)
	    {
	      out.print(owner[0].toString() + "/" + owner[1].toString() + "<br>");
	    }
	    
	    //out.print(System.getProperties());
	    out.print("</body>");
	    out.print("</html>");
	  }

}
